// Package gen provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package gen

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	"github.com/oapi-codegen/runtime"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /openapi.json)
	Openapi(ctx echo.Context) error

	// (GET /v1/healthz)
	Healthcheck(ctx echo.Context) error

	// (GET /v1/metrics)
	Metrics(ctx echo.Context) error

	// (GET /v1/tool/{toolname}/builds)
	List(ctx echo.Context, toolname string) error

	// (POST /v1/tool/{toolname}/builds)
	Start(ctx echo.Context, toolname string) error

	// (GET /v1/tool/{toolname}/builds/latest)
	Latest(ctx echo.Context, toolname string) error

	// (DELETE /v1/tool/{toolname}/builds/{id})
	Delete(ctx echo.Context, toolname string, id string) error

	// (GET /v1/tool/{toolname}/builds/{id})
	Get(ctx echo.Context, toolname string, id string) error

	// (PUT /v1/tool/{toolname}/builds/{id}/cancel)
	Cancel(ctx echo.Context, toolname string, id string) error

	// (GET /v1/tool/{toolname}/builds/{id}/logs)
	Logs(ctx echo.Context, toolname string, id string, params LogsParams) error

	// (POST /v1/tool/{toolname}/clean)
	Clean(ctx echo.Context, toolname string) error

	// (GET /v1/tool/{toolname}/quotas)
	Quota(ctx echo.Context, toolname string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// Openapi converts echo context to params.
func (w *ServerInterfaceWrapper) Openapi(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Openapi(ctx)
	return err
}

// Healthcheck converts echo context to params.
func (w *ServerInterfaceWrapper) Healthcheck(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Healthcheck(ctx)
	return err
}

// Metrics converts echo context to params.
func (w *ServerInterfaceWrapper) Metrics(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Metrics(ctx)
	return err
}

// List converts echo context to params.
func (w *ServerInterfaceWrapper) List(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.List(ctx, toolname)
	return err
}

// Start converts echo context to params.
func (w *ServerInterfaceWrapper) Start(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Start(ctx, toolname)
	return err
}

// Latest converts echo context to params.
func (w *ServerInterfaceWrapper) Latest(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Latest(ctx, toolname)
	return err
}

// Delete converts echo context to params.
func (w *ServerInterfaceWrapper) Delete(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Delete(ctx, toolname, id)
	return err
}

// Get converts echo context to params.
func (w *ServerInterfaceWrapper) Get(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Get(ctx, toolname, id)
	return err
}

// Cancel converts echo context to params.
func (w *ServerInterfaceWrapper) Cancel(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Cancel(ctx, toolname, id)
	return err
}

// Logs converts echo context to params.
func (w *ServerInterfaceWrapper) Logs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Parameter object where we will unmarshal all parameters from the context
	var params LogsParams
	// ------------- Optional query parameter "follow" -------------

	err = runtime.BindQueryParameter("form", true, false, "follow", ctx.QueryParams(), &params.Follow)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter follow: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Logs(ctx, toolname, id, params)
	return err
}

// Clean converts echo context to params.
func (w *ServerInterfaceWrapper) Clean(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Clean(ctx, toolname)
	return err
}

// Quota converts echo context to params.
func (w *ServerInterfaceWrapper) Quota(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "toolname" -------------
	var toolname string

	err = runtime.BindStyledParameterWithOptions("simple", "toolname", ctx.Param("toolname"), &toolname, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter toolname: %s", err))
	}

	ctx.Set(KeyScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.Quota(ctx, toolname)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/openapi.json", wrapper.Openapi)
	router.GET(baseURL+"/v1/healthz", wrapper.Healthcheck)
	router.GET(baseURL+"/v1/metrics", wrapper.Metrics)
	router.GET(baseURL+"/v1/tool/:toolname/builds", wrapper.List)
	router.POST(baseURL+"/v1/tool/:toolname/builds", wrapper.Start)
	router.GET(baseURL+"/v1/tool/:toolname/builds/latest", wrapper.Latest)
	router.DELETE(baseURL+"/v1/tool/:toolname/builds/:id", wrapper.Delete)
	router.GET(baseURL+"/v1/tool/:toolname/builds/:id", wrapper.Get)
	router.PUT(baseURL+"/v1/tool/:toolname/builds/:id/cancel", wrapper.Cancel)
	router.GET(baseURL+"/v1/tool/:toolname/builds/:id/logs", wrapper.Logs)
	router.POST(baseURL+"/v1/tool/:toolname/clean", wrapper.Clean)
	router.GET(baseURL+"/v1/tool/:toolname/quotas", wrapper.Quota)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xacW/buhH/KgQ3YC3g2ErbYZv/S9O8zqibZEmDDUiC4CyeLb5SpEJSdv0Cf/eBpCRb",
	"lhw7fUna19d/glgU7368+/F4d9QdjVWaKYnSGtq/oxpNpqRB/2MEbC8DDSla1P5JrKRFad2/kGWCx2C5",
	"kr1fjZLumYkTTMH991eNY9qnf+ktxffCqOmdFTo+ojEwQUMXi0WHMjSx5pmTR/v0LTCyVE0yMAYZXXQc",
	"grHgsX1WNCpD7WWTUr0hM24TYhMkca41SkuMBYtEjQmQUc4Fe2FeOsBcWtQSxB5qrfSzwj6QpNROvHaS",
	"QJahDJaUyu6NVS7Zs2L6lCARYNHYYCUyA0OksiRAWXRoLiG3idL8N3xeaBerit1wMdnJfuuweghCnIxp",
	"//J+df71QyUZ97IXnTuaacciy4ut5V644V6knWdI+9RYzeWEBliWS7/MG57CBFvfQsluLE/bB+vbdivU",
	"0+Xrbt0WtN0ke9Epn6jRrxhburhedOjagvvr602D3Vuxuo2T74bzPLzaAqKAMFSTpnLB5W4rKYSc1oxX",
	"l4VyOoUwACysFsRp7ZU2f67Q7EhOuVYydTFjCprDSKAhIBmZgsjREKvICIlBS6DcJN4XLXA9O24kBE81",
	"d5obcSHJxSn/biHcSbVLgUuo3gHrks5VrmMksWJINI5Ro4yDJA/uBX7pEiATbslIg4wTr/Zlm3jjJd3k",
	"WjS1XJwNnUwHNctHgsdeosZMGW6VnhObgHUB2AKXxr9nlsCuZInnSjY1+5Xd5ly7kHK5CuN6EwnOK1ai",
	"zFM36+3FYPju5uzi+Hhw/J52it/nF4eHR+fn1e9fDgbDi7Oj6vfhwfHh0XB49K568mnw8ejk4lP1++L4",
	"w/HJf49XoCwNdggyRlFGryYdQwSpG3LASpfHfrZAFizT5pG0DIgPD6AtljsUCHIz2sdV9g4FWvxa2zA/",
	"+9ks8x7tZqSj8nTZGgAfH9i/EYRNnsJnq5G93EMnH2iHHp2dnZy10L0N3tDnCt+n6YZ8K7JARIup2Rlj",
	"oQa0hvnjYz7GWZXL1PGWp8hj5hJtCP6TKwtN9TFYnChd7t1dTOYlHYZ586bpNiqvpjRDRqn24foHFtM2",
	"920w61ZwXl4DIEyBC5cxtHoqhgxibuetg4Kn3LaObPR8bpA9BPvTRJHbkjBbfdEOrSGzcSq4jWzcwVDC",
	"JKM5yTRXmtt5x5UnGLIPm6BGMuNCuCwKyAy05HJCwuMEpT9aULJMcWkJN2SEbpxhptExnF1JXzhyOVY6",
	"DTWlkiRRM5f7ZFrFiMz9m2fMlZPcdn0+s5aElqVkRdOG69Zp6BQ+bEaxtodMarP+uSsmnoYYEmc3O8X/",
	"Kui1IHTHFMa58/S5ez1A+Yx+E3HHjgSBoablPqH/2/uklBgrPUH/3zJ5gIx/wHmoLUuDW27dbqXVnJBx",
	"GHJwOqAdOkVtAglfdaNu5JalMpSQcdqnr7v73ch5H2ziYfWKsW5Z/U7Qb+mqQTFgtE9PCgGdejvnVRQ9",
	"qJ5eN1SjktFoc12k4gUwwnDMZVH1+im96X4v8TnGbxsBhxwkTjD+/HtB30eDtVSnZUVnKysKoEnIYcqs",
	"0aCe8hidm/4evX52ZMiWUaaA4oKMVK5QAjav0Zn2L69LD6RoNY/NRg98LMa3Wt/iF9vLBPB2slRHxL2m",
	"LdA0jLoBvFVK9O7cX7cDF71lZtW6FhfNaT1tuVyP+McrhbENe9jvdbfTlju9VElXy0erc+zcs/LrJ2Rw",
	"LePcYmTBjXVLLKy16NA30f4mBRXiXq395mkebZ+01uRcc2QRTi+vfasoU6bFaf6Y+NZeu83R2LeKzR/N",
	"Yc2MeLGOavGEfKkfvltCuMSZmJNYI1R18WqeEhi0AxnWrg2+lnhvojfbJy2b2I9O1Q79shcrhhOUewU1",
	"9kaKzfcKmi2zj/vjVC+0uzeHqzD8gwasevm+w4XAn41mW8hzx9kiFCwCLTbZE5pg35A9nc0ttrK1hl8y",
	"oRjS/hiEwVbVnD1EaYcaO/dZteFpJpA+KYfX+owbOLy8zSo6i386Infa49t7tD/p+YT0XO0sb+Vm5fuf",
	"IbYWYnvhqsT3J/IWEod7mJ88fkIer111baVy8NgfIc6+if61fUb1Ycs3ob9Qk3sKajf4XVP/d1O9qeQX",
	"JYSahUo6rN8ruc1Rz5daxv4tuiqZ4RhyYattWGgaKSUQ5E759qYmy9ZKc6gm91V5rsLjEolB50tX5RlX",
	"2MjYu+7qfsFXlCh9JWtvVS8NCjIeOS5eUcLHZa8cDAFZfH4EY4vaDVxJYzVC6nvnYIj/4gQZeQFF783a",
	"rOy8+c8OYpB/s2SEJE5ATpC9vJI/T7GwjWNPK3dwtTZW/JX8D1pd1j83uKcfBsTkaQp67hY5S8CGE8RN",
	"R0byrPu9tMc2+NhfgW0O0OHy68f0cf1icUvP09up2bT6Dvzqh/S03TVDFYMgjGuMLWE4RaEy/31YmNKl",
	"Heo/maIuLvZ7vf1X/+hG3ai73/9nFEW0eXgNeQp7n7lQW6WZmrjXURT1qoZx44uy6gqr+qz04HRAJmBx",
	"BvPq2rOpADLeNdO468hlunjLge13Z/wzT5Fx6MZC5czrfr2L8hF6H389AidgNxTXi/8HAAD//1wL87Qh",
	"LQAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
